#ifndef oagRedun_P
#define oagRedun_P
#include "oagRedunStuckAtRedunCB.h"

class oa::oaDesign;

namespace oagRedun {

// Exceptions are duplicated here for the benefit of end-user code
struct FloatingNetException : public std::exception {
    virtual const char* what() const throw() {
	return "Redundancy remover encountered a floating net";
    }
};
struct CycleException : public std::exception {
    virtual const char* what() const throw() {
	return "Redundancy remover encountered a cycle";
    }
};

void removeStuckAtRedundancies(oa::oaDesign *, StuckAtRedunCB *, unsigned seed);
void removeUnusedLogic(oa::oaDesign *);

}

#endif
